import numpy as np
import random
from Classes import Objet
from Classes import Liste_Objets
from Classes import Individu
from Classes import Population
################################################################################
# Les Listes ###################################################################
################################################################################

# Les listes d'objet sont des tableau de couples (valeurs, poids)

LE1 = [[1,5],[5,2],[6,3],[5,7],[10,2],[3,7],[2,2],[1,1],[6,7],[5,9]]

LE2 = [[6, 12],[13, 16],[17, 14],[10, 10],[9, 5],[8, 15],[15, 2],[6, 4],[3, 7],
     [1, 14],[17, 16],[11, 10],[6, 12],[5, 5],[4, 13],[10, 0],[15, 3],[15, 13],
     [15, 14],[8, 6],[9, 3],[7, 9],[13, 14],[14, 7],[6, 11],[14, 13],[15, 15],
     [14, 3],[5, 1],[11, 4],[8, 14],[1, 9],[0, 1],[0, 7],[3, 12],[8, 9],[3, 5],
     [16, 1],[4, 6],[3, 3],[1, 13],[6, 2],[11, 15],[4, 10],[4, 13],[9, 15],
     [2, 12],[4, 9],[5, 6],[8, 11],[3, 5],[7, 9],[4, 5],[5, 10],[10, 3],[8, 15],
     [7, 14],[10, 13],[8, 13],[9, 14],[0, 10],[0, 11],[5, 0],[11, 12],[9, 6],
     [17, 3],[12, 13],[10, 3],[17, 2],[2, 16],[4, 9],[14, 4],[9, 6],[8, 14],
     [0, 8],[5, 7],[2, 4],[14, 12],[7, 5],[14, 0],[16, 13],[3, 4],[3, 2],[1, 2],
     [15, 15],[9, 15],[1, 6],[8, 5],[4, 12],[4, 8],[8, 3],[16, 7],[3, 7],[1, 8],
     [17, 5],[4, 16],[6, 7],[6, 9],[13, 1],[10, 10]]

LE3 = [[5,5],[6,8],[2,3],[1,7],[8,2]]

coeffMutation = 0.01
#coeffMutation = 0.95
coeffEnjambement = 0.7
#coeffEnjambement = 0.95

espacement = "######################################################################"

def nbTest():
    fic = open('/home/bertrand/Bureau/Autre/Informatique/Saves/nbtest.txt','r')
    l = int(fic.read())
    fic.close()
    return l

def nbTestIncr(l):
    i = int(nbTest())
    i += l
    fic = open('/home/bertrand/Bureau/Autre/Informatique/Saves/nbtest.txt','w')
    fic.write(str(i))
    fic.close()

LOE1 = Liste_Objets.listeToListObjet(LE1)

LOE2 = Liste_Objets.listeToListObjet(LE2)

LOE3 = Liste_Objets.listeToListObjet(LE3)

################################################################################
# Algorithme genetique #########################################################
################################################################################

# Prend en argument un individu et modifie un de ces genes avec une probabilite p
# Utilisee dans : nouvelleGeneration

def mutation(combi,p):
    n = len(combi.listeAssociee)
    x = random.random()
    if x < p:
        x = random.randint(0,n-1)
        combi.change(x)

# Prend en argument deux individus et les croisent par rapport a p% de leurs genes
# Utilisee dans : nouvelleGeneration

def croisement(a,b,p):
    an = a.copier()
    bn = b.copier()
    n = len(a.listeAssociee)
    nb = int(n*p)+1
    L = random.sample([i for i in range(n)],nb)
    for l in L:
        if a[l] != b[l]:
            an.change(l)
            bn.change(l)
    return (an,bn)

# Prend en argument une population et met en place les intervalles proportionne a leur utilité
# Utilisee dans : selection

def roueDeLaFortune(pop):
    n = len(pop)
    utilites = []
    mini = pop.minUtilite
    somme = 0
    for i in range(n): #On cree un liste contenant les couples (indice, utilite)
        k = pop[i].utilite
        utilites.append((i,k))
    maxi = 0
    i = 0
    while i < len(utilites):
        if utilites[i][1] == "NULLE":
            utilites.pop(i)
        else:
            utilites[i] = (utilites[i][0],utilites[i][1] - mini) #On soustrait la valeur minimum
            if Individu.compareMinVal(maxi,utilites[i][1]): #Pour n'avoir que des valeurs >= 0
                maxi = utilites[i][1]
            i += 1
    maxi = np.abs(0.01*maxi) #On donne une petite chance au plus nul (Qui est à 0)
    for i in range(len(utilites)):
        utilites[i] = (utilites[i][0],utilites[i][1] + maxi)
        somme += utilites[i][1] #Et on en profite pour calculer la somme
    rdlf = []
    r = 0
    for i in range(len(utilites)): #On ramene sur un pour pouvoir faire des tirages
        if somme != 0:
            utilites[i] = (utilites[i][0],utilites[i][1] / somme)
        rdlf.append((utilites[i][0],r, r + utilites[i][1]))
        r += utilites[i][1]
    if len(rdlf) != 0:
        rdlf[-1] = (rdlf[-1][0],rdlf[-1][1],1)
    return rdlf

# Met a jour la roue une fois un individu sélectionné.
# Utilisee dans : selection

def updateRoue(rdlf):
    n = len(rdlf)
    somme = 0
    for i in range(n):
        somme += rdlf[i][2]-rdlf[i][1]
    r = 0
    for i in range(n):
        if somme != 0:
            ecart = (rdlf[i][2]-rdlf[i][1]) / somme
            rdlf[i] = (rdlf[i][0],r,r+ ecart)
            r += ecart
    rdlf[-1] = (rdlf[-1][0],rdlf[-1][1],1)
    return rdlf

# Prend en argument une liste de (indice individu concerné, debut intervalle, fin intervalle)
# et retourne l'indice pour lequel i est dans l'intervalle
# Utilisee dans : selection

def indicer(i,r):
    n = len(r)
    for j in range(n):
        m = r[j]
        if i >= m[1] and i < m[2]:
            return j,m[0]
    return -1

# Effectue une selection des individus d'une population
# Utilisee dans : resolGenetique

def selection(popu,l,M):
    selectionnee = Population(l,M)
    roue = roueDeLaFortune(popu)
    while len(selectionnee) < (len(popu)/2) and len(roue) > 0:
        x = random.random()
        indiceselect = indicer(x,roue)
        if indiceselect != -1:
            selectionnee.naissance(popu[indiceselect[1]])
            roue.pop(indiceselect[0])
            if len(roue) != 0:
                roue = updateRoue(roue)
    return selectionnee

# Prend en argument une population ainsi que les indices de mutation et enjambement et
# Effectue l'enjambement et les mutation sur cette population.
# Utilisee dans : resolGenetique

def nouvelleGeneration(popu,mut,enj,l,M):
    n = len(popu)
    nouvelleGen = Population(l,M)
    for i in range(n//2):
        a,b = croisement(popu[i*2],popu[(i*2)+1],enj)
        mutation(a,mut)
        mutation(b,mut)
        nouvelleGen.naissance(a)
        nouvelleGen.naissance(b)
    return nouvelleGen

# resout genetiquement le problème du sac à dos
# Utilisee dans : None

def resolGenetique(pop,mut,enj,lo,sac,gen,pri):
    # Population initiale, coefficients d'enjambement et de mutation, liste d'objet, sac, nombre de génération, Print le déroulement ?)
    i = nbTest()
    genetiquesave = open('/home/bertrand/Bureau/Autre/Informatique/Saves/genetiquesave'+str(i)+'.txt','w')
    l = espacement + "\nLancement numéro : " + str(i) + "\n"
    nbTestIncr(1)
    popu = Population(lo,sac)
    popu.aleat(pop)
    l += "Génération d'origine :\n" + str(popu) +"\n"
    if pri:
        print(espacement),print(popu)
    for i in range(gen):
        input("Press Enter to continue...")
        l += espacement + "\nGénération : " + str(i) + "\n"
        if pri:
            print(espacement),print("Génération :", i)
        selectionnee = selection(popu,lo,sac)
        if pri:
            print(espacement),print("Selection faite")
        nouvelleGen = nouvelleGeneration(selectionnee,mut,enj,lo,sac)
        if pri:
            print(espacement),print("Nouvelle génération créée")
        popu = selectionnee + nouvelleGen
        l += str(popu) + "\n"
        if pri:
            print(espacement),print(popu)
    best = popu.meilleurIndividu()
    l += espacement + "\nRésultat trouvé : " + str(best)
    genetiquesave.write(l)
    genetiquesave.close()
    return best

#resolGenetique(10,coeffMutation,coeffEnjambement,LOE3,10,10,True)